Option Explicit On 

Module T4CE

    ' Error Codes

    Public Const T4_NOERROR As Integer = &H0

    Public Const T4_NOTAG = &H1
    Public Const T4_DATAERROR = &H2
    Public Const T4_WRITEERROR = &H3
    Public Const T4_ADRESSERROR = &H4
    Public Const T4_WRONGTAG = &H5
    Public Const T4_READERROR = &H6
    Public Const T4_NOTSELECTED = &H7
    Public Const T4_WRONGTAGPW = &H8

    Public Const T4_PARAERRWRITE = &H10
    Public Const T4_PARANOTVALID = &H11
    Public Const T4_PARAERRPWCYCLE = &H12
    Public Const T4_PARANOLOGIN = &H13
    Public Const T4_PARAWRONGPW = &H14

    Public Const T4_READERCHPWFAIL = &H60

    Public Const T4_UNKNOWNCOMMAND = &H80
    Public Const T4_WRONGLENGTH = &H81
    Public Const T4_CMDNOTAVAILABLE = &H82
    Public Const T4_COMERRORRFMODULE = &H83

    Public Const T4_RX_WRONGLENGTH = &H93
    Public Const T4_WRONGBLOCKCNT = &H95
    Public Const T4_POLLNOTINIT = &H96

    Public Const T4_ALREADYINIT = &HA0
    Public Const T4_NOTINIT = &HA1
    Public Const T4_V24_INITFAIL = &HA2
    Public Const T4_NOREADERSELECTED = &HA4

    Public Const T4_RX_TIMEOUT = &HB1
    Public Const T4_RX_WRONGANSWER = &HB2
    Public Const T4_RX_WRONGCSUM = &HB3
    Public Const T4_RX_PARITY = &HB4
    Public Const T4_RX_OVERRUN = &HB5
    Public Const T4_RX_FRAME = &HB6

    ' Definitions of Transpondertypes

    Public Const T4_TYPE_IDRO_A = 0
    Public Const T4_TYPE_IDRW_B = 1
    Public Const T4_TYPE_IDRW_C = 2
    Public Const T4_TYPE_IDRW_D = 3
    Public Const T4_TYPE_IDRW_E = 4
    Public Const T4_TYPE_IDRO_G = 5

    Public Const T4_MSK_IDRO_A = &H1
    Public Const T4_MSK_IDRW_B = &H2
    Public Const T4_MSK_IDRW_C = &H4
    Public Const T4_MSK_IDRW_D = &H8
    Public Const T4_MSK_IDRW_E = &H10
    Public Const T4_MSK_IDRO_G = &H20

    ' Initialization/Deinitialization
    Declare Function T4FindCOMPortNr Lib "t4ce.dll" Alias "T4FindCOMPortNr" () As Integer
    Declare Function T4FindCOMPort Lib "t4ce.dll" Alias "T4FindCOMPort" () As IntPtr
    Declare Function T4Init Lib "t4ce.dll" Alias "T4Init" (ByVal ComPort As String) As Integer
    Declare Function T4DeInit Lib "t4ce.dll" Alias "T4DeInit" () As Integer

    ' Selecting a Tag
    Declare Function T4SelectTag Lib "t4ce.dll" Alias "T4SelectTag" (ByRef TagType As Byte, ByRef SerialNumber As Byte) As Integer
    Declare Function T4SelectTagPW Lib "t4ce.dll" Alias "T4SelectTagPW" (ByRef PassWord As Byte, ByRef TagType As Byte, ByRef SerialNumber As Byte) As Integer
    Declare Function T4InitTagPoll Lib "t4ce.dll" Alias "T4InitTagPoll" (ByRef PassWord As Byte) As Integer
    Declare Function T4DoTagPoll Lib "t4ce.dll" Alias "T4DoTagPoll" (ByRef TagType As Byte, ByRef SerialNumber As Byte) As Integer

    ' Reading/Writing Tags
    Declare Function T4WriteData Lib "t4ce.dll" Alias "T4WriteData" (ByVal BlockAdress As Byte, ByVal BlockCount As Byte, ByRef Data As Byte) As Integer
    Declare Function T4ReadData Lib "t4ce.dll" Alias "T4ReadData" (ByVal BlockAdress As Byte, ByVal BlockCount As Byte, ByRef Data As Byte) As Integer
    Declare Function T4WriteConfigData Lib "t4ce.dll" Alias "T4WriteConfigData" (ByVal BlockAdress As Byte, ByRef Data As Byte) As Integer
    Declare Function T4ReadConfigData Lib "t4ce.dll" Alias "T4ReadConfigData" (ByVal BlockAdress As Byte, ByRef Data As Byte) As Integer

    ' Configuring the Transponder Reader
    Declare Function T4ConfigurationReset Lib "t4ce.dll" Alias "T4ConfigurationReset" () As Integer
    Declare Function T4SetTagDriver Lib "t4ce.dll" Alias "T4SetTagDriver" (ByVal Driver As Byte) As Integer
    Declare Function T4SetTagOptions Lib "t4ce.dll" Alias "T4SetTagOptions" (ByVal TagType As Byte, ByVal TagOptions As Byte) As Integer

    ' Reading Versions
    Declare Function T4VersionTagReader Lib "t4ce.dll" Alias "T4VersionTagReader" (ByRef Version As Byte) As Integer
    Declare Function T4VersionLibrary Lib "t4ce.dll" Alias "T4VersionLibrary" () As Integer

    ' Misc
    Declare Function T4GetStatusString Lib "t4ce.dll" Alias "T4GetStatusString" (ByVal Status As Integer) As IntPtr

End Module
